%define _disable_ld_no_undefined 1

%define mod_name mod_php
%define load_order 70

%define build_test 0
%{?_with_test: %{expand: %%global build_test 1}}
%{?_without_test: %{expand: %%global build_test 0}}

%define build_libmagic 0
%{?_with_libmagic: %{expand: %%global build_libmagic 1}}
%{?_without_libmagic: %{expand: %%global build_libmagic 0}}

%global __requires_exclude BEGIN|mkinstalldirs|pear\\(|/usr/bin/tclsh

%define php_common_major 7
%define libname %mklibname php_common %{php_common_major}

# enforce versioned postgresql dependencies because of multiple version
# availability in the distribution
%define postgresql_version %(pg_config &>/dev/null && pg_config 2>/dev/null | awk '/^VERSION/ { print $4 }' | sed -re 's/rc[0-9]+$//'|| echo 0)

%define _RC %nil

Summary:	The PHP scripting language
Name:		php
Version:	7.4.2
Release:	%mkrel 1
Source0:	http://fr2.php.net/distributions/php-%{version}.tar.xz
Group:		Development/PHP
License:	PHP License
URL:		http://www.php.net
Source1:	php-test-ini
Source2:	maxlifetime
Source3:	php.crond
Source4:	php-fpm.service
Source5:	php-fpm.sysconf
Source6:	php-fpm.logrotate
# S7 comes from ext/fileinfo/create_data_file.php but could be removed someday
Source7:	create_data_file.php
# ini based on production version
Source8:	php-ini
Source9:	php-fpm-tmpfiles.conf
Source10:	70_php-fpm.conf
Source11:	php.ini-production-orig
Source12:	php.ini-development-orig
#automatic adding does not work on build server
Source101:	05_assertion.ini
Source102:	05_date.ini
Source103:	05_mail.ini
Source104:	05_pcre.ini
Source105:	10_bz2.ini
Source106:	11_calendar.ini
Source107:	12_ctype.ini
Source108:	13_curl.ini
Source109:	14_dba.ini
Source1010:	18_dom.ini
Source1011:	19_exif.ini
Source1012:	21_openssl.ini
Source1013:	21_zlib.ini
Source1014:	22_ftp.ini
Source1015:	23_gd.ini
Source1016:	24_gettext.ini
Source1017:	25_gmp.ini
Source1018:	26_iconv.ini
Source1019:	27_imap.ini
Source1020:	27_intl.ini
Source1021:	28_ldap.ini
Source1022:	29_mbstring.ini
Source1023:	32_fileinfo.ini
Source1024:	33_mysqlnd.ini
Source1025:	37_mysqli.ini
Source1026:	38_enchant.ini
Source1027:	39_odbc.ini
Source1028:	40_pcntl.ini
Source1030:	42_pgsql.ini
Source1031:	43_posix.ini
Source1032:	45_readline.ini
Source1034:	47_session.ini
Source1035:	48_shmop.ini
Source1036:	50_snmp.ini
Source1037:	51_soap.ini
Source1038:	52_sockets.ini
Source1040:	56_sysvmsg.ini
Source1041:	57_sysvsem.ini
Source1042:	58_sysvshm.ini
Source1043:	59_tidy.ini
Source1044:	60_tokenizer.ini
Source1046:	62_xmlrpc.ini
Source1048:	63_xmlreader.ini
Source1049:	63_xsl.ini
Source1050:	64_xmlwriter.ini
Source1051:	66_bcmath.ini
Source1052:	70_pdo.ini
Source1053:	71_pdo_dblib.ini
Source1054:	73_pdo_mysql.ini
Source1055:	75_pdo_odbc.ini
Source1056:	76_pdo_pgsql.ini
Source1057:	77_pdo_sqlite.ini
Source1058:	78_pdo_firebird.ini
Source1059:	78_sqlite3.ini
Source1060:	81_filter.ini
Source1061:	82_json.ini
Source1062:	83_zip.ini
Source1063:	84_phar.ini
Source1064:	99_opcache.ini
Source1065:	85_sodium.ini
Source1066: 98_ffi.ini
Patch1:		php-shared.diff
Patch2:		php-7.1-mga_php.ini.diff
Patch5:		php-phpbuilddir.diff
Patch8:		php-xmlrpc_epi.patch
Patch9:		php-xmlrpc_no_rpath.diff
Patch11:	php-7.0.2RC1-libdb.diff
#####################################################################
# Stolen from PLD
Patch22:	php-dba-link.patch
Patch23:	php-zlib-for-getimagesize.patch
#(spuhler) taken from Mandriva
Patch29:	php-7.0.0RC5-fpm-0.6.5-shared.diff
Patch30:	php-7.0.0RC5-fpm-0.6.5-mdv_conf.diff
#####################################################################
# stolen from debian
Patch50:	php-session.save_path.diff
Patch51:	php-exif_nesting_level.diff
#####################################################################
# Stolen from fedora
# Functional changes
#Patch115:	php-dlopen.diff
#why do we want to have them public?
Patch226:	php-no-fvisibility_hidden_fix.diff
Patch228:	php-5.3.0RC2-xmlrpc-epi_fix.diff
Patch229:	php-7.0.2RC1-session.use_strict_mode.diff
# apache-mod_php
Patch400:	php-7.0.0RC5-apache-mod_php.diff

BuildRequires:	apache-devel
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRequires:	bison
BuildRequires:	mercurial
BuildRequires:	python
BuildRequires:	byacc
BuildRequires:	bzip2-devel
BuildRequires:	c-client-devel
BuildRequires:	pkgconfig(libcurl)
BuildRequires:	db-devel
BuildRequires:	elfutils-devel
BuildRequires:	pkgconfig(enchant-2)
BuildRequires:	file
BuildRequires:	flex
BuildRequires:	freetds-devel
BuildRequires:	freetype2-devel
BuildRequires:	gdbm-devel
BuildRequires:	gettext-devel
BuildRequires:	gmp-devel
BuildRequires:	gpm-devel
BuildRequires:	icu-devel
BuildRequires:	lemon
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	libldap-devel
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libsasl2)
BuildRequires:	libtool-devel
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(libxml-2.0) 
BuildRequires:	pkgconfig(xpm)
BuildRequires:	pkgconfig(libxslt)
BuildRequires:	pkgconfig(libwebp)
BuildRequires:	pkgconfig(libzip)
BuildRequires:	mbfl-devel
# for mysql_config
BuildRequires:	mysql-devel
BuildRequires:	pkgconfig(ncurses)
BuildRequires:	net-snmp-devel
BuildRequires:	net-snmp-mibs
BuildRequires:	openssl
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pam-devel
BuildRequires:	pkgconfig(libpcre2-posix)
BuildRequires:	postgresql-devel
BuildRequires:	re2c
BuildRequires:	readline-devel
BuildRequires:	pkgconfig(libedit)
BuildRequires:	pkgconfig(sqlite3)
BuildRequires:	pkgconfig(libsodium)
BuildRequires:	lib64tidy-html-devel
BuildRequires:	unixODBC-devel
BuildRequires:	xmlrpc-epi-devel
BuildRequires:  lib64fbclient-devel
BuildRequires:  lib64oniguruma-devel
BuildRequires:  lib64gd-devel

%if %{build_libmagic}
BuildRequires:	file-devel
%endif


%description
PHP is an HTML-embeddable scripting language. PHP offers built-in database
integration for several commercial and non-commercial database management
systems, so writing a database-enabled script with PHP is fairly simple. The
most common use of PHP coding is probably as a replacement for CGI scripts.

%package	ini
Summary:	INI files for PHP
Group:		Development/PHP
Requires:	php >= %{version}

%description	ini
The php-ini package contains the ini file required for PHP.


%package -n	apache-mod_php
Summary:	The PHP HTML-embedded scripting language for use with apache
Group:		System/Servers
Requires(pre):	rpm-helper
Requires(postun): rpm-helper
Requires:	apache
Requires:	%{libname} >= %{version}
Provides:	php-webinterface = %{version}-%{release}

%description -n apache-mod_php
PHP is an HTML-embeddable scripting language. PHP offers built-in database
integration for several commercial and non-commercial database management
systems, so writing a database-enabled script with PHP is fairly simple. The
most common use of PHP coding is probably as a replacement for CGI scripts.

This package contains the PHP apache module.

%package	cli
Summary:	PHP CLI interface
Group:		Development/PHP
URL:		http://www.php.net/cli
Requires:	%{libname} >= %{version}
Provides:	php = %{version}
Provides:	/usr/bin/php

%description	cli
PHP is an HTML-embeddable scripting language. PHP offers built-in database
integration for several commercial and non-commercial database management
systems, so writing a database-enabled script with PHP is fairly simple. The
most common use of PHP coding is probably as a replacement for CGI scripts.

This package contains a command-line (CLI) version of php. You must also
install %{libname}. If you need apache module support, you also need to
install the apache-mod_php package.

%package	cgi
Summary:	PHP CGI interface
Group:		Development/PHP

Requires:	%{libname} >= %{version}
Requires:	webserver-base
Provides:	php = %{version}
Provides:	php-fcgi = %{version}-%{release}
Provides:	php-webinterface = %{version}-%{release}
Obsoletes:	php-fcgi < %{version}-%{release}

%description	cgi
PHP is an HTML-embeddable scripting language. PHP offers built-in database
integration for several commercial and non-commercial database management
systems, so writing a database-enabled script with PHP is fairly simple. The
most common use of PHP coding is probably as a replacement for CGI scripts.

This package contains a standalone (CGI) version of php with FastCGI support.
You must also install %{libname}. If you need apache module support, you
also need to install the apache-mod_php package.

%package -n	%{libname}
Summary:	Shared library for PHP
Group:		Development/PHP
Provides:	php-hash = %{version}
Provides:	php-xml = %{version}
Provides:	php-pcre = %{version}
Provides:	php-simplexml = %{version}
Requires:	php >= %{version}
Requires:	php-ctype >= %{version}
Requires:	php-filter >= %{version}
Requires:	php-ftp >= %{version}
Requires:	php-gettext >= %{version}
Requires:	php-ini >= %{version}
Requires:	php-json >= %{version}
Requires:	php-openssl >= %{version}
Requires:	php-pcre >= %{version}
Requires:	php-posix >= %{version}
Requires:	php-session >= %{version}
Requires:	php-sysvsem >= %{version}
Requires:	php-sysvshm >= %{version}
Requires:	php-tokenizer >= %{version}
Requires:	php-xmlreader >= %{version}
Requires:	php-xmlwriter >= %{version}
Requires:	php-zlib >= %{version}
#obsoletes added for #2017
Obsoletes:	php-amf
Obsoletes:	php-apacheaccessor
Obsoletes:	php-apm < 2.1.3
Obsoletes:	php-auth_nds
Obsoletes:	php-awl
Obsoletes:	php-bbcode
Obsoletes:	php-bloomy
Obsoletes:	php-braille
Obsoletes:	php-cairo
Obsoletes:	php-cairo_wrapper
Obsoletes:	php-cyrus
Obsoletes:	php-dav
Obsoletes:	php-dbx
Obsoletes:	php-docblock
Obsoletes:	php-docblock
Obsoletes:	php-doublemetaphone
Obsoletes:	php-ecasound
Obsoletes:	php-esmtp
Obsoletes:	php-fam
Obsoletes:	php-gearman
Obsoletes:	php-gnutls
Obsoletes:	php-hash
Obsoletes:	php-haru
Obsoletes:	php-hidef
Obsoletes:	php-htscanner
Obsoletes:	php-id3
Obsoletes:	php-inclued
Obsoletes:	php-interbase
Obsoletes:	php-layersmenu
Obsoletes:	php-libevent
Obsoletes:	php-magickwand
Obsoletes:	php-mailparse < 3.0.2
Obsoletes:	php-mcal
Obsoletes:	php-mcal < 0.6-51
Obsoletes:	php-mdbtools
Obsoletes:	php-ming
Obsoletes:	php-mongo
Obsoletes:	php-mssql
Obsoletes:	php-netools
Obsoletes:	php-newt
Obsoletes:	php-oggvorbis
Obsoletes:	php-optimizer
Obsoletes:	php-pam
Obsoletes:	php-pear-Date_Holidays
Obsoletes:	php-pear-Horde
Obsoletes:	php-pear-PHP_Parser
Obsoletes:	php-pear-PHP_Parser_DocblockParser
Obsoletes:	php-pinba
Obsoletes:	php-pluf
Obsoletes:	php-rar < 4.0.0
Obsoletes:	php-recode
Obsoletes:	php-sasl
Obsoletes:	php-suhosin
Obsoletes:	php-swish
Obsoletes:	php-sybase_ct
Obsoletes:	php-symfony-YAML
Obsoletes:	php-syslog-ng
Obsoletes:	php-tclink
Obsoletes:	php-timezonedb
Obsoletes:	php-txforward
Obsoletes:	php-uploadprogress
Obsoletes:	php-wbxml
Obsoletes:	php-wddx
Obsoletes:	php-xml
Obsoletes:	php-yrmcds
Obsoletes:	php-ZendFramework

%description -n	%{libname}
This package provides the common files to run with different implementations of
PHP. You need this package if you install the php standalone package or a
webserver with php support (ie: apache-mod_php).

%package	devel
Summary:	Development package for PHP
Group:		Development/PHP
Requires:	%{libname} >= %{version}
Requires:	autoconf automake libtool
Requires:	bison
Requires:	byacc
Requires:	chrpath
Requires:	dos2unix
Requires:	flex
Requires:	libxml2-devel
Requires:	libxslt-devel
Requires:	openssl
Requires:	openssl-devel
Requires:	pam-devel
Requires:	pcre-devel 
Requires:	re2c 
Requires:	tcl

%description	devel
The php-devel package lets you compile dynamic extensions to PHP. Included
here is the source for the php extensions. Instead of recompiling the whole php
binary to add support for, say, oracle, install this package and use the new
self-contained extensions support.

%package	openssl
Summary:	OpenSSL extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/openssl
Requires:	%{libname} >= %{version}

%description	openssl
This is a dynamic shared object (DSO) for PHP that will add OpenSSL support.

%package	zlib
Summary:	Zlib extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/zlib
Requires:	%{libname} >= %{version}

%description	zlib
This is a dynamic shared object (DSO) for PHP that will add zlib compression
support to PHP.

%package	doc
Summary:	Documentation for PHP
Group:		Development/PHP
BuildArch:	noarch

%description	doc
Documentation for php.

%package	bcmath
Summary:	The bcmath module for PHP
Group:		Development/PHP
URL:		http://www.php.net/bcmath
Requires:	%{libname} >= %{version}

%description	bcmath
This is a dynamic shared object (DSO) for PHP that will add bc style precision
math functions support.

For arbitrary precision mathematics PHP offers the Binary Calculator which
supports numbers of any size and precision, represented as strings.

%package	bz2
Summary:	Bzip2 extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/bzip2
Requires:	%{libname} >= %{version}

%description	bz2
This is a dynamic shared object (DSO) for PHP that will add bzip2 compression
support to PHP.

The bzip2 functions are used to transparently read and write bzip2 (.bz2)
compressed files.

%package	calendar
Summary:	Calendar extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/calendar
Requires:	%{libname} >= %{version}

%description	calendar
This is a dynamic shared object (DSO) for PHP that will add calendar support.

The calendar extension presents a series of functions to simplify converting
between different calendar formats. The intermediary or standard it is based on
is the Julian Day Count. The Julian Day Count is a count of days starting from
January 1st, 4713 B.C. To convert between calendar systems, you must first
convert to Julian Day Count, then to the calendar system of your choice. Julian
Day Count is very different from the Julian Calendar! For more information on
Julian Day Count, visit http://www.hermetic.ch/cal_stud/jdn.htm. For more
information on calendar systems visit
http://www.boogle.com/info/cal-overview.html. Excerpts from this page are
included in these instructions, and are in quotes.

%package	ctype
Summary:	Ctype extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/ctype
Requires:	%{libname} >= %{version}

%description	ctype
This is a dynamic shared object (DSO) for PHP that will add ctype support.

The functions provided by this extension check whether a character or string
falls into a certain character class according to the current locale (see also
setlocale()).

%package	curl
Summary:	Curl extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/curl
Requires:	%{libname} >= %{version}

%description	curl
This is a dynamic shared object (DSO) for PHP that will add curl support.

PHP supports libcurl, a library created by Daniel Stenberg, that allows you to
connect and communicate to many different types of servers with many different
types of protocols. libcurl currently supports the http, https, ftp, gopher,
telnet, dict, file, and ldap protocols. libcurl also supports HTTPS
certificates, HTTP POST, HTTP PUT, FTP uploading (this can also be done with
PHP's ftp extension), HTTP form based upload, proxies, cookies, and
user+password authentication.

%package	dba
Summary:	DBA extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/dba
Requires:	%{libname} >= %{version}

%description	dba
This is a dynamic shared object (DSO) for PHP that will add flat-file databases
(DBA) support.

These functions build the foundation for accessing Berkeley DB style databases.

This is a general abstraction layer for several file-based databases. As such,
functionality is limited to a common subset of features supported by modern
databases such as Sleepycat Software's DB2. (This is not to be confused with
IBM's DB2 software, which is supported through the ODBC functions.)

%package	dom
Summary:	Dom extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/dom
Requires:	%{libname} >= %{version}

%description	dom
This is a dynamic shared object (DSO) for PHP that will add dom support.

The DOM extension is the replacement for the DOM XML extension from PHP 4. The
extension still contains many old functions, but they should no longer be used.
In particular, functions that are not object-oriented should be avoided.

The extension allows you to operate on an XML document with the DOM API.

%package	enchant
Summary:	Libenchant binder, support near all spelling tools
Group:		Development/PHP
URL:		http://www.php.net/
Requires:	%{libname} >= %{version}

%description	enchant
Enchant is a binder for libenchant. Libenchant provides a common API for many
spell libraries:

 - aspell/pspell (intended to replace ispell)
 - hspell (hebrew)
 - ispell
 - hunspell (OpenOffice project, mozilla)
 - uspell (primarily Yiddish, Hebrew, and Eastern European languages)
   A plugin system allows to add custom spell support.
   see www.abisource.com/enchant/

%package	exif
Summary:	EXIF extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/exif
Requires:	%{libname} >= %{version}
Requires:	php-mbstring >= %{version}

%description	exif
This is a dynamic shared object (DSO) for PHP that will add EXIF tags support
in image files.

With the exif extension you are able to work with image meta data. For example,
you may use exif functions to read meta data of pictures taken from digital
cameras by working with information stored in the headers of the JPEG and TIFF
images.

%package	fileinfo
Summary:	Fileinfo extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/fileinfo
Requires:	%{libname} >= %{version}

%description	fileinfo
This extension allows retrieval of information regarding vast majority of file.
This information may include dimensions, quality, length etc...

Additionally it can also be used to retrieve the mime type for a particular
file and for text files proper language encoding.

%package	filter
Summary:	Extension for safely dealing with input parameters
Group:		Development/PHP
URL:		http://www.php.net/filter
Requires:	%{libname} >= %{version}

%description	filter
The Input Filter extension is meant to address this issue by implementing a set
of filters and mechanisms that users can use to safely access their input data.

%package	ftp
Summary:	FTP extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/ftp
Requires:	%{libname} >= %{version}

%description	ftp
This is a dynamic shared object (DSO) for PHP that will add FTP support.

The functions in this extension implement client access to file servers
speaking the File Transfer Protocol (FTP) as defined in
http://www.faqs.org/rfcs/rfc959. This extension is meant for detailed access to
an FTP server providing a wide range of control to the executing script. If you
only wish to read from or write to a file on an FTP server, consider using the
ftp:// wrapper with the filesystem functions  which provide a simpler and more
intuitive interface.

%package	gd
Summary:	GD extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/gd
Requires:	%{libname} >= %{version}
Provides:	php-gd-bundled = %{version}

%description	gd
This is a dynamic shared object (DSO) for PHP that will add GD support,
allowing you to create and manipulate images with PHP using the gd library.

PHP is not limited to creating just HTML output. It can also be used to create
and manipulate image files in a variety of different image formats, including
gif, png, jpg, wbmp, and xpm. Even more convenient, PHP can output image
streams directly to a browser. You will need to compile PHP with the GD library
of image functions for this to work. GD and PHP may also require other
libraries, depending on which image formats you want to work with.

You can use the image functions in PHP to get the size of JPEG, GIF, PNG, SWF,
TIFF and JPEG2000 images.

%package	gettext
Summary:	Gettext extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/gettext
Requires:	%{libname} >= %{version}

%description	gettext
This is a dynamic shared object (DSO) for PHP that will add gettext support.

The gettext functions implement an NLS (Native Language Support) API which can
be used to internationalize your PHP applications. Please see the gettext
documentation for your system for a thorough explanation of these functions or
view the docs at http://www.gnu.org/software/gettext/manual/gettext.html.

%package	gmp
Summary:	Gmp extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/gmp
Requires:	%{libname} >= %{version}

%description	gmp
This is a dynamic shared object (DSO) for PHP that will add arbitrary length
number support using the GNU MP library.

%package	iconv
Summary:	Iconv extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/iconv
Requires:	%{libname} >= %{version}

%description	iconv
This is a dynamic shared object (DSO) for PHP that will add iconv support.

This module contains an interface to iconv character set conversion facility.
With this module, you can turn a string represented by a local character set
into the one represented by another character set, which may be the Unicode
character set. Supported character sets depend on the iconv implementation of
your system. Note that the iconv function on some systems may not work as you
expect. In such case, it'd be a good idea to install the GNU libiconv library.
It will most likely end up with more consistent results.

%package	imap
Summary:	IMAP extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/iamp
Requires:	%{libname} >= %{version}

%description	imap
This is a dynamic shared object (DSO) for PHP that will add IMAP support.

These functions are not limited to the IMAP protocol, despite their name. The
underlying c-client library also supports NNTP, POP3 and local mailbox access
methods.

%package	intl
Summary:	Internationalization extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/intl
Requires:	%{libname} >= %{version}

%description	intl
This is a dynamic shared object (DSO) for PHP that will add
Internationalization support.

Internationalization extension implements ICU library functionality in PHP.

%package	json
Summary:	JavaScript Object Notation
Group:		Development/PHP
URL:		http://www.php.net/json
Requires:	%{libname} >= %{version}

%description	json
Support for JSON (JavaScript Object Notation) serialization.

%package	ldap
Summary:	LDAP extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/ldap
Requires:	%{libname} >= %{version}

%description	ldap
This is a dynamic shared object (DSO) for PHP that will add LDAP support.

LDAP is the Lightweight Directory Access Protocol, and is a protocol used to
access "Directory Servers". The Directory is a special kind of database that
holds information in a tree structure.

The concept is similar to your hard disk directory structure, except that in
this context, the root directory is "The world" and the first level
subdirectories are "countries". Lower levels of the directory structure contain
entries for companies, organisations or places, while yet lower still we find
directory entries for people, and perhaps equipment or documents.

%package	mbstring
Summary:	MBstring extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/mbstring
Requires:	%{libname} >= %{version}

%description	mbstring
This is a dynamic shared object (DSO) for PHP that will add multibyte string
support.

mbstring provides multibyte specific string functions that help you deal with
multibyte encodings in PHP. In addition to that, mbstring handles character
encoding conversion between the possible encoding pairs. mbstring is designed
to handle Unicode-based encodings such as UTF-8 and UCS-2 and many single-byte
encodings for convenience.

%package	mysqli
Summary:	MySQL database module for PHP
Group:		Development/PHP
URL:		http://www.php.net/mysqli
Requires:	%{libname} >= %{version}
Requires:	%{name}-mysqlnd = %{version}

%description	mysqli
This is a dynamic shared object (DSO) for PHP that will add MySQL database
support.

The mysqli extension allows you to access the functionality provided by MySQL
4.1 and above. It is an improved version of the older PHP MySQL driver,
offering various benefits. The developers of the PHP programming language
recommend using MySQLi when dealing with MySQL server versions 4.1.3 and newer
(takes advantage of new functionality)

More information about the MySQL Database server can be found at
http://www.mysql.com/

Documentation for MySQL can be found at http://dev.mysql.com/doc/.

Documentation for MySQLi can be found at http://www.php.net/manual/en/mysqli.overview.php.

%package	mysqlnd
Summary:	MySQL native database module for PHP
Group:		Development/PHP
URL:		http://www.php.net/mysqlnd
Requires:	%{libname} >= %{version}
Requires:	php-hash
Provides:	php-mysql = %{version}-%{release}
Obsoletes:	php-mysql

%description	mysqlnd
This is a dynamic shared object (DSO) for PHP that will add MySQL native
database support.

These functions allow you to access MySQL database servers. More information
about MySQL can be found at http://www.mysql.com/.

Documentation for MySQL can be found at http://dev.mysql.com/doc/.

%package	odbc
Summary:	ODBC extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/odbc
Requires:	%{libname} >= %{version}

%description	odbc
This is a dynamic shared object (DSO) for PHP that will add ODBC support.

In addition to normal ODBC support, the Unified ODBC functions in PHP allow you
to access several databases that have borrowed the semantics of the ODBC API to
implement their own API. Instead of maintaining multiple database drivers that
were all nearly identical, these drivers have been unified into a single set of
ODBC functions.

%package	opcache
Summary:	Zend OPcache for PHP
Group:		Development/PHP
URL:		http://www.php.net/opcache
Requires:	%{libname} >= %{version}
Obsoletes:	php-xcache < 3.2.1
Obsoletes:	php-xcache-admin < 3.2.1

%description	opcache
This is a dynamic shared object (DSO) for PHP that will add OPcache support.

The Zend OPcache provides faster PHP execution through opcode caching and
optimization. It improves PHP performance by storing precompiled script
bytecode in the shared memory. This eliminates the stages of reading code from
the disk and compiling it on future access. In addition, it applies a few
bytecode optimization patterns that make code execution faster.

%package	pcntl
Summary:	Process Control extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/pcntl
Requires:	%{libname} >= %{version}

%description	pcntl
This is a dynamic shared object (DSO) for PHP that will add process spawning
and control support. It supports functions like fork(), waitpid(), signal()
etc.

Process Control support in PHP implements the Unix style of process creation,
program execution, signal handling and process termination. Process Control
should not be enabled within a webserver environment and unexpected results may
happen if any Process Control functions are used within a webserver
environment.

%package	pdo
Summary:	PHP Data Objects Interface
Group:		Development/PHP
URL:		http://www.php.net/pdo
Requires:	%{libname} >= %{version}

%description	pdo
PDO provides a uniform data access interface, sporting advanced features such
as prepared statements and bound parameters. PDO drivers are dynamically
loadable and may be developed independently from the core, but still accessed
using the same API.

Read the documentation at http://www.php.net/pdo for more information.

%package	pdo_dblib
Summary:	Sybase Interface driver for PDO
Group:		Development/PHP
URL:		http://www.php.net/pdo_dblib
Requires:	freetds
Requires:	php-pdo >= %{version}
Requires:	%{libname} >= %{version}

%description	pdo_dblib
PDO_DBLIB is a driver that implements the PHP Data Objects (PDO) interface to
enable access from PHP to Microsoft SQL Server and Sybase databases through the
FreeTDS libary.

%package	pdo_firebird
Summary:	Firebird/InterBase driver for PDO
Group:		Development/PHP
URL:		http://www.php.net/pdo_firebird
Requires:	php-pdo >= %{version}
Requires:	%{libname} >= %{version}

%description	pdo_firebird
PDO_Firebird is a driver that implements the PHP Data Objects (PDO) interface to
enable access from PHP to Firebird databases.

%package	pdo_mysql
Summary:	MySQL Interface driver for PDO
Group:		Development/PHP
URL:		http://www.php.net/pdo_mysql
Requires:	php-pdo >= %{version}
Requires:	%{libname} >= %{version}
Requires:	%{name}-mysqlnd = %{version}

%description	pdo_mysql
PDO_MYSQL is a driver that implements the PHP Data Objects (PDO) interface to
enable access from PHP to MySQL 3.x, 4.x and 5.x databases.

PDO_MYSQL will take advantage of native prepared statement support present in
MySQL 4.1 and higher. If you're using an older version of the mysql client
libraries, PDO will emulate them for you.

Please note that this build does NOT support compression protocol because it
is built with MySQL Native Driver (mysqlnd).

%package	pdo_odbc
Summary:	ODBC v3 Interface driver for PDO
Group:		Development/PHP
URL:		http://www.php.net/pdo_odbc
Requires:	php-pdo >= %{version}
Requires:	%{libname} >= %{version}

%description	pdo_odbc
PDO_ODBC is a driver that implements the PHP Data Objects (PDO) interface to
enable access from PHP to databases through ODBC drivers or through the IBM DB2
Call Level Interface (DB2 CLI) library. PDO_ODBC currently supports three
different "flavours" of database drivers:

 o ibm-db2  - Supports access to IBM DB2 Universal Database, Cloudscape, and
              Apache Derby servers through the free DB2 client. ibm-db2 is not
              supported in Mageia.

 o unixODBC - Supports access to database servers through the unixODBC driver
              manager and the database's own ODBC drivers.

 o generic  - Offers a compile option for ODBC driver managers that are not
              explicitly supported by PDO_ODBC.

%package	pdo_pgsql
Summary:	PostgreSQL interface driver for PDO
Group:		Development/PHP
URL:		http://www.php.net/pdo_pgsql
Requires:	php-pdo >= %{version}
Requires:	%{libname} >= %{version}
Requires:	postgresql-libs >= %{postgresql_version}

%description	pdo_pgsql
PDO_PGSQL is a driver that implements the PHP Data Objects (PDO) interface to
enable access from PHP to PostgreSQL databases.

%package	pdo_sqlite
Summary:	SQLite v3 Interface driver for PDO
Group:		Development/PHP
URL:		http://www.php.net/pdo_sqlite
Requires:	php-pdo >= %{version}
Requires:	%{libname} >= %{version}

%description	pdo_sqlite
PDO_SQLITE is a driver that implements the PHP Data Objects (PDO) interface to
enable access to SQLite 3 databases.

This extension provides an SQLite v3 driver for PDO. SQLite V3 is NOT
compatible with the bundled SQLite 2 in PHP 5, but is a significant step
forwards, featuring complete utf-8 support, native support for blobs, native
support for prepared statements with bound parameters and improved concurrency.

%package	pgsql
Summary:	PostgreSQL database module for PHP
Group:		Development/PHP
URL:		http://www.php.net/pgsql
Requires:	%{libname} >= %{version}
Requires:	postgresql-libs >= %{postgresql_version}

%description	pgsql
This is a dynamic shared object (DSO) for PHP that will add PostgreSQL database
support.

PostgreSQL database is Open Source product and available without cost.
Postgres, developed originally in the UC Berkeley Computer Science Department,
pioneered many of the object-relational concepts now becoming available in some
commercial databases. It provides SQL92/SQL99 language support, transactions,
referential integrity, stored procedures and type extensibility. PostgreSQL is
an open source descendant of this original Berkeley code.

%package	phar
Summary:	Allows running of complete applications out of .phar files
Group:		Development/PHP
URL:		http://www.php.net/phar
Requires:	%{libname} >= %{version}
Requires:	php-bz2
Requires:	php-hash

%description	phar
This is the extension version of PEAR's PHP_Archive package. Support for
zlib, bz2 and crc32 is achieved without any dependency other than the external
zlib or bz2 extension.

.phar files can be read using the phar stream, or with the Phar class. If the
SPL extension is available, a Phar object can be used as an array to iterate
over a phar's contents or to read files directly from the phar.

Phar archives can be created using the streams API or with the Phar class, if
the phar.readonly ini variable is set to false.

Full support for MD5 and SHA1 signatures is possible. Signatures can be
required if the ini variable phar.require_hash is set to true. When PECL
extension hash is avaiable then SHA-256 and SHA-512 signatures are supported as
well.

%package	posix
Summary:	POSIX extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/posix
Requires:	%{libname} >= %{version}

%description	posix
This is a dynamic shared object (DSO) for PHP that will add POSIX functions
support to PHP.

This module contains an interface to those functions defined in the IEEE 1003.1
(POSIX.1) standards document which are not accessible through other means.
POSIX.1 for example defined the open(), read(), write() and close() functions,
too, which traditionally have been part of PHP 3 for a long time. Some more
system specific functions have not been available before, though, and this
module tries to remedy this by providing easy access to these functions.

%package	readline
Summary:	Readline extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/readline
Requires:	%{libname} >= %{version}

%description	readline
This PHP module adds support for readline functions (only for cli and cgi
SAPIs).

The readline() functions implement an interface to the GNU Readline library.
These are functions that provide editable command lines. An example being the
way Bash allows you to use the arrow keys to insert characters or scroll
through command history. Because of the interactive nature of this library, it
will be of little use for writing Web applications, but may be useful when
writing scripts used from a command line.

%package	session
Summary:	Session extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/session
Requires(pre):	rpm-helper
Requires(postun): rpm-helper
Requires:	%{libname} >= %{version}
Requires:	webserver-base

%description	session
This is a dynamic shared object (DSO) for PHP that will add session support.

Session support in PHP consists of a way to preserve certain data across
subsequent accesses. This enables you to build more customized applications and
increase the appeal of your web site.

A visitor accessing your web site is assigned a unique id, the so-called
session id. This is either stored in a cookie on the user side or is propagated
in the URL.

%package	shmop
Summary:	Shared Memory Operations extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/shmop
Requires:	%{libname} >= %{version}

%description	shmop
This is a dynamic shared object (DSO) for PHP that will add Shared Memory
Operations support.

Shmop is an easy to use set of functions that allows PHP to read, write, create
and delete Unix shared memory segments.

%package	snmp
Summary:	NET-SNMP extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/snmp
Requires:	net-snmp-mibs
Requires:	%{libname} >= %{version}

%description	snmp
This is a dynamic shared object (DSO) for PHP that will add SNMP support using
the NET-SNMP libraries.

In order to use the SNMP functions you need to install the NET-SNMP package.

%package	soap
Summary:	Soap extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/soap
Requires:	%{libname} >= %{version}

%description	soap
This is a dynamic shared object (DSO) for PHP that will add soap support.

The SOAP extension can be used to write SOAP Servers and Clients. It supports
subsets of SOAP 1.1, SOAP 1.2 and WSDL 1.1 specifications.

%package	sockets
Summary:	Sockets extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/sockets
Requires:	%{libname} >= %{version}

%description	sockets
This is a dynamic shared object (DSO) for PHP that will add sockets support.

The socket extension implements a low-level interface to the socket
communication functions based on the popular BSD sockets, providing the
possibility to act as a socket server as well as a client.

%package	sodium
Summary:	Wrapper for the Sodium cryptographic library
Group:		Development/PHP
URL:		http://php.net/manual/en/book.sodium.php
Requires:       %{libname} >= %{version}

%description	sodium
This is a dynamic shared object (DSO) for PHP that will add libsodium support.

%package	sqlite3
Summary:	SQLite database bindings for PHP
Group:		Development/PHP
URL:		http://www.php.net/sqlite3
Requires:	php-pdo >= %{version}
Requires:	%{libname} >= %{version}
Obsoletes:	php-sqlite < 1.0.4

%description	sqlite3
This is an extension for the SQLite Embeddable SQL Database Engine. SQLite is a
C library that implements an embeddable SQL database engine. Programs that link
with the SQLite library can have SQL database access without running a separate
RDBMS process.

SQLite is not a client library used to connect to a big database server. SQLite
is the server. The SQLite library reads and writes directly to and from the
database files on disk.

%package	sysvmsg
Summary:	SysV msg extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/sem
Requires:	%{libname} >= %{version}

%description	sysvmsg
This is a dynamic shared object (DSO) for PHP that will add SysV message queues
support.

%package	sysvsem
Summary:	SysV sem extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/sem
Requires:	%{libname} >= %{version}

%description	sysvsem
This is a dynamic shared object (DSO) for PHP that will add SysV semaphores
support.

%package	sysvshm
Summary:	SysV shm extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/sem
Requires:	%{libname} >= %{version}

%description	sysvshm
This is a dynamic shared object (DSO) for PHP that will add SysV Shared Memory
support.

%package	tidy
Summary:	Tidy HTML Repairing and Parsing for PHP
Group:		Development/PHP
URL:		http://www.php.net/tidy
Requires:	%{libname} >= %{version}

%description	tidy
Tidy is a binding for the Tidy HTML clean and repair utility which allows you
to not only clean and otherwise manipluate HTML documents, but also traverse
the document tree using the Zend Engine 2 OO semantics.

%package	tokenizer
Summary:	Tokenizer extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/tokenizer
Requires:	%{libname} >= %{version}

%description	tokenizer
This is a dynamic shared object (DSO) for PHP that will add Tokenizer support.

The tokenizer functions provide an interface to the PHP tokenizer embedded in
the Zend Engine. Using these functions you may write your own PHP source
analyzing or modification tools without having to deal with the language
specification at the lexical level.

%package	xmlreader
Summary:	Xmlreader extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/xmlreader
Requires:	php-dom >= %{version}
Requires:	%{libname} >= %{version}

%description	xmlreader
XMLReader represents a reader that provides non-cached, forward-only access to
XML data. It is based upon the xmlTextReader api from libxml

%package	xmlrpc
Summary:	Xmlrpc extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/xmlrpc
Requires:	%{libname} >= %{version}

%description	xmlrpc
This is a dynamic shared object (DSO) for PHP that will add XMLRPC support.

These functions can be used to write XML-RPC servers and clients. You can find
more information about XML-RPC at http://www.xmlrpc.com/, and more
documentation on this extension and its functions at
http://xmlrpc-epi.sourceforge.net/.

%package	xmlwriter
Summary:	Provides fast, non-cached, forward-only means to write XML data
Group:		Development/PHP
URL:		http://www.php.net/xmlwriter
Requires:	%{libname} >= %{version}

%description	xmlwriter
This extension wraps the libxml xmlWriter API. Represents a writer that
provides a non-cached, forward-only means of generating streams or files
containing XML data.

%package	xsl
Summary:	Xsl extension module for PHP
Group:		Development/PHP
URL:		http://www.php.net/xsl
Requires:	%{libname} >= %{version}

%description	xsl
This is a dynamic shared object (DSO) for PHP that will add xsl support.

The XSL extension implements the XSL standard, performing XSLT transformations
using the libxslt library

%package	zip
Summary:	A zip management extension for PHP
Group:		Development/PHP
URL:		http://www.php.net/zip
Requires:	%{libname} >= %{version}

%description	zip
This is a dynamic shared object (DSO) for PHP that will add zip support to
create and read zip files using the libzip library.

%package	fpm
Summary:	PHP FastCGI Process Manager
Group:		Development/PHP
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre):	rpm-helper
Requires(postun): rpm-helper
Requires:	%{libname} >= %{version}
Requires:	webserver-base
Provides:	php-webinterface = %{version}-%{release}
Provides:	php = %{version}

%description	fpm
PHP is an HTML-embeddable scripting language. PHP offers built-in database
integration for several commercial and non-commercial database management
systems, so writing a database-enabled script with PHP is fairly simple. The
most common use of PHP coding is probably as a replacement for CGI scripts.

This package contains the FastCGI Process Manager. You must also install
%{libname}.

%package -n	phpdbg
Summary:	The interactive PHP debugger
Group:		Development/PHP
Requires:	%{libname} >= %{version}
Requires:	php >= %{version}

%description -n	phpdbg
PHP is an HTML-embeddable scripting language. PHP offers built-in database
integration for several commercial and non-commercial database management
systems, so writing a database-enabled script with PHP is fairly simple. The
most common use of PHP coding is probably as a replacement for CGI scripts.

This package contains the The interactive PHP debugger. You must also install
%{libname}.

Implemented as a SAPI module, phpdbg can excert complete control over the
environment without impacting the functionality or performance of your code.

phpdbg aims to be a lightweight, powerful, easy to use debugging platform for
PHP5.4+

%prep

%setup -qn php-%{version}
%apply_patches


mv sapi/apache2handler/mod_php%{php_common_major}.c sapi/apache2handler/mod_php.c

cp %{SOURCE1} php-test.ini
cp %{SOURCE4} php-fpm.service
cp %{SOURCE5} php-fpm.sysconf
cp %{SOURCE6} php-fpm.logrotate
cp %{SOURCE7} create_data_file.php
cp %{SOURCE10} 00-php-fpm.conf

# Change perms otherwise rpm would get fooled while finding requires
find -name "*.inc" | xargs chmod 644
find -name "*.php*" | xargs chmod 644
find -name "*README*" | xargs chmod 644

mkdir -p php-devel/extensions
mkdir -p php-devel/sapi

# Install test files in php-devel
cp -a tests php-devel

cp -dpR ext/* php-devel/extensions/
rm -f php-devel/extensions/informix/stub.c
rm -f php-devel/extensions/standard/.deps
rm -f php-devel/extensions/skeleton/EXPERIMENTAL

# SAPI
cp -dpR sapi/* php-devel/sapi/
rm -f php-devel/sapi/thttpd/stub.c
rm -f php-devel/sapi/cgi/php.sym
rm -f php-devel/sapi/fastcgi/php.sym
rm -f php-devel/sapi/pi3web/php.sym

# cleanup
find php-devel -name "*.droplet" | xargs rm -f

# don't ship MS Windows source
rm -rf php-devel/extensions/com_dotnet

# likewise with these:
find php-devel -name "*.dsp" | xargs rm -f
find php-devel -name "*.mak" | xargs rm -f
find php-devel -name "*.w32" | xargs rm

# make sure using system libs
rm -rf ext/pcre/pcrelib
rm -rf ext/pdo_sqlite/sqlite
rm -rf ext/xmlrpc/libxmlrpc

%build
%serverbuild

export CFLAGS="${CFLAGS} -O3 -fno-strict-aliasing -fvisibility=default"
export LDFLAGS="%{ldflags} -O3 -lz"
export CXXFLAGS="${CXXFLAGS} -O3 -fvisibility=default -fvisibility-inlines-hidden"

cat > php-devel/buildext <<EOF
#!/bin/bash
gcc -Wall -fPIC -shared $CFLAGS \\
    -I. \`%{_bindir}/php-config --includes\` \\
    -I%{_includedir}/libxml2 \\
    -I%{_includedir}/freetype \\
    -I%{_includedir}/openssl \\
    -I%{_usrsrc}/php-devel/ext \\
    -I%{_includedir}/\$1 \\
    \$4 \$2 -o \$1.so \$3 -lc
EOF

chmod 755 php-devel/buildext

#export PHP_AUTOCONF=autoconf-2.13
rm -f configure
rm -rf autom4te.cache
./buildconf --force

# Do this patch with a perl hack...
perl -pi -e "s|'\\\$install_libdir'|'%{_libdir}'|" ltmain.sh

export oldstyleextdir=yes
export EXTENSION_DIR="%{_libdir}/php/extensions"
export PROG_SENDMAIL="%{_sbindir}/sendmail"
export GD_SHARED_LIBADD="$GD_SHARED_LIBADD -lm"
export ENCHANT_CFLAGS=`pkgconf --cflags enchant-2`
export ENCHANT_LIBS=`pkgconf --libs enchant-2`

# never use "--disable-rpath", it does the opposite

# Configure php
for i in fpm cgi cli apxs; do
./configure \
    `[ $i = fpm ] && echo --disable-cli --enable-fpm --with-fpm-user=apache --with-fpm-group=apache` \
    `[ $i = cgi ] && echo --disable-cli` \
    `[ $i = cli ] && echo --disable-cgi --enable-cli` \
    `[ $i = apxs ] && echo --with-apxs2=%{_httpd_apxs}` \
    --with-pic \
    --build=%{_build} \
    --prefix=%{_prefix} \
    --exec-prefix=%{_prefix} \
    --bindir=%{_bindir} \
    --sbindir=%{_sbindir} \
    --sysconfdir=%{_sysconfdir} \
    --datadir=%{_datadir} \
    --includedir=%{_includedir} \
    --libdir=%{_libdir} \
    --libexecdir=%{_libexecdir} \
    --localstatedir=/var/lib \
    --mandir=%{_mandir} \
    --enable-shared=yes \
    --enable-static=no \
    --disable-debug  \
    --enable-bcmath=shared \
    --enable-calendar=shared \
    --enable-ctype=shared \
    --enable-dba=shared \
    --enable-dom=shared,%{_prefix} \
    --enable-exif=shared \
    --enable-fileinfo=shared \
    --enable-filter=shared \
    --enable-ftp=shared \
    --enable-gd=shared \
    --enable-inline-optimization \
    --enable-intl=shared \
    --enable-json=shared \
    --enable-mbregex \
    --enable-mbstring=shared,%{_prefix} \
    --enable-mysqlnd=shared,%{_bindir}/mysql_config \
    --enable-opcache=shared \
    --enable-pcntl=shared \
    --enable-pdo=shared,%{_prefix} \
    --enable-phar=shared \
    --enable-phpdbg \
    --enable-phpdbg-webhelper \
    --enable-posix=shared \
    --enable-session=shared,%{_prefix} \
    --enable-shmop=shared,%{_prefix} \
    --enable-simplexml \
    --enable-soap=shared,%{_prefix} \
    --enable-sockets=shared,%{_prefix} \
    --enable-sysvmsg=shared,%{_prefix} \
    --enable-sysvsem=shared,%{_prefix} \
    --enable-sysvshm=shared,%{_prefix} \
    --enable-tokenizer=shared,%{_prefix} \
    --enable-xmlreader=shared,%{_prefix} \
    --enable-xmlwriter=shared,%{_prefix} \
    --with-zip=shared \
    --with-bz2=shared,%{_prefix} \
    --with-cdb  \
    --with-config-file-path=%{_sysconfdir} \
    --with-config-file-scan-dir=%{_sysconfdir}/php.d \
    --with-curl=shared,%{_prefix} \
    --with-db4 \
    --with-enchant=shared,%{_prefix} \
    --with-freetype=%{_prefix} \
    --with-gdbm \
    --with-external-gd=shared,%{_prefix} \
    --with-gettext=shared,%{_prefix} \
    --with-gmp=shared,%{_prefix} \
    --with-iconv=shared \
    --with-imap=shared,%{_prefix} \
    --with-imap-ssl=%{_prefix} \
    --with-jpeg=%{_prefix} \
    --with-ldap-sasl \
    --with-ldap=shared,%{_prefix} \
    --with-libdir=%{_lib} \
    --with-mysqli=shared,mysqlnd \
    --with-mysql-sock=/var/lib/mysql/mysql.sock \
    --with-openssl-dir=%{_prefix} \
    --with-openssl=shared,%{_prefix} \
    --without-pear \
    --with-external-pcre=%{_prefix} \
    --with-pcre-jit \
    --with-pdo-dblib=shared,%{_prefix} \
    --with-pdo-firebird=shared,%{_libdir}/firebird \
    --with-pdo-mysql=shared,mysqlnd \
    --with-pdo-odbc=shared,unixODBC,%{_prefix} \
    --with-pdo-pgsql=shared,%{_prefix}  \
    --with-pdo-sqlite=shared,%{_prefix} \
    --with-pgsql=shared,%{_prefix} \
    --with-readline=shared,%{_prefix} \
    --with-snmp=shared,%{_prefix} \
	--with-sodium=shared,%{_prefix} \
    --with-sqlite3=shared,%{_prefix} \
    --with-system-ciphers \
    --with-tidy=shared,%{_prefix} \
    --with-unixODBC=shared,%{_prefix} \
    --with-webp=%{_prefix} \
    --with-xmlrpc=shared,%{_prefix} \
    --with-xpm=%{_prefix}/X11R6 \
    --with-xsl=shared,%{_prefix} \
    --with-zlib=shared,%{_prefix} \
    --with-zlib-dir=%{_prefix}

cp -f Makefile Makefile.$i

# left for debugging purposes
cp -f main/php_config.h php_config.h.$i

# when all else failed...
#perl -pi -e "s|-prefer-non-pic -static||g" Makefile.$i

done

%make_build

%if %{build_libmagic}
# keep in sync with latest system magic, the next best thing when system libmagic can't be used...
sapi/cli/php create_data_file.php %{_datadir}/misc/magic.mgc > ext/fileinfo/data_file.c
rm -rf ext/fileinfo/.libs ext/fileinfo/*.lo ext/fileinfo/*.la modules/fileinfo.so modules/fileinfo.la
cp -p ext/fileinfo/data_file.c php-devel/extensions/fileinfo/data_file.c
%make_build
%endif

# make php-cgi
cp -af php_config.h.cgi main/php_config.h
make -f Makefile.cgi sapi/cgi/php-cgi
cp -af php_config.h.apxs main/php_config.h

# make php-fpm
cp -af php_config.h.fpm main/php_config.h
make -f Makefile.fpm sapi/fpm/php-fpm
cp -af php_config.h.apxs main/php_config.h

%install

install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_sysconfdir}/php.d
install -d %{buildroot}%{_libdir}/php/extensions
install -d %{buildroot}%{_usrsrc}/php-devel
install -d %{buildroot}%{_mandir}/man1
install -d %{buildroot}%{_sysconfdir}/cron.d
install -d %{buildroot}/var/lib/php
install -d %{buildroot}%{_datadir}/php

make -f Makefile.apxs install \
	INSTALL_ROOT=%{buildroot} \
	INSTALL_IT="\$(LIBTOOL) --mode=install install libphp%{php_common_major}_common.la %{buildroot}%{_libdir}/"

# borked autopoo
rm -f %{buildroot}%{_bindir}/php %{buildroot}%{_bindir}/php-cgi %{buildroot}%{_bindir}/phpdbg
./libtool --silent --mode=install install sapi/cli/php %{buildroot}%{_bindir}/php
./libtool --silent --mode=install install sapi/cgi/php-cgi %{buildroot}%{_bindir}/php-cgi
./libtool --silent --mode=install install sapi/phpdbg/phpdbg %{buildroot}%{_bindir}/phpdbg

# compat php-fcgi symlink
ln -s php-cgi %{buildroot}%{_bindir}/php-fcgi

cp -dpR php-devel/* %{buildroot}%{_usrsrc}/php-devel/
install -m0644 run-tests*.php %{buildroot}%{_usrsrc}/php-devel/
install -m0644 main/internal_functions.c %{buildroot}%{_usrsrc}/php-devel/

install -m0644 sapi/cli/php.1 %{buildroot}%{_mandir}/man1/
install -m0644 scripts/man1/phpize.1 %{buildroot}%{_mandir}/man1/
install -m0644 scripts/man1/php-config.1 %{buildroot}%{_mandir}/man1/

# fpm
#install -d %{buildroot}%{_unitdir}
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_sysconfdir}/php-fpm.d
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_mandir}/man8
install -d %{buildroot}/var/lib/php-fpm
install -d %{buildroot}/var/log/php-fpm
#install -D -p -m 0644 %{SOURCE9} %{buildroot}%{_tmpfilesdir}/php-fpm.conf
# a small bug here...
echo "; place your config here" > %{buildroot}%{_sysconfdir}/php-fpm.d/default.conf
install -m0644 sapi/fpm/www.conf %{buildroot}%{_sysconfdir}/php-fpm.d/

./libtool --silent --mode=install install sapi/fpm/php-fpm %{buildroot}%{_sbindir}/php-fpm
install -m0644 sapi/fpm/php-fpm.8 %{buildroot}%{_mandir}/man8/
install -m0644 sapi/fpm/php-fpm.conf %{buildroot}%{_sysconfdir}/
#install -m0644 php-fpm.service %{buildroot}%{_unitdir}/php-fpm.service
install -m0644 php-fpm.sysconf %{buildroot}%{_sysconfdir}/sysconfig/php-fpm
install -m0644 php-fpm.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/php-fpm
install -d %{buildroot}%{_httpd_modconfdir}
install -m0644 00-php-fpm.conf %{buildroot}%{_httpd_modconfdir}/00-php-fpm.conf

# adjust a bit
perl -pi -e "s|^pid.*|pid = /run/php-fpm/php-fpm.pid|g" %{buildroot}%{_sysconfdir}/php-fpm.conf

ln -snf extensions %{buildroot}%{_usrsrc}/php-devel/ext

install -d %{buildroot}%{_httpd_moddir}
install -d %{buildroot}%{_httpd_modconfdir}

install -m0755 .libs/libphp%{php_common_major}.so %{buildroot}%{_httpd_moddir}/%{mod_name}.so

cat > %{buildroot}%{_httpd_modconfdir}/%{load_order}_%{mod_name}.conf <<EOF
LoadModule php_module modules/%{mod_name}.so

AddType application/x-httpd-php .php
AddType application/x-httpd-php .phtml
AddType application/x-httpd-php-source .phps

DirectoryIndex index.php index.phtml
EOF

# extensions
install -m0644 %{_sourcedir}/*.ini %{buildroot}%{_sysconfdir}/php.d/
install -m0755 %{SOURCE2} %{buildroot}%{_libdir}/php/maxlifetime
install -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/cron.d/php
install -m0644 %{SOURCE8} %{buildroot}%{_sysconfdir}/php.ini
install -m0644 %{SOURCE8} %{buildroot}%{_sysconfdir}/php-cgi-fcgi.ini

# lib64 hack
perl -pi -e "s|/usr/lib/|%{_libdir}/|" \
    %{buildroot}%{_sysconfdir}/cron.d/php \
    %{buildroot}%{_sysconfdir}/php.ini \
    %{buildroot}%{_sysconfdir}/php-cgi-fcgi.ini \
    php.ini-production \
    php.ini-development

# install doc manually in _docdir/php, rather than _docdir/php-doc
install -d -m 755 %{buildroot}%{_docdir}/php
install -m 644 \
    CODING_STANDARDS.md EXTENSIONS LICENSE NEWS \
    php.ini-production php.ini-development \
    README.md README.REDIST.BINS UPGRADING UPGRADING.INTERNALS \
    %{buildroot}%{_docdir}/php

# fix docs
cp Zend/LICENSE Zend/ZEND_LICENSE
cp ext/openssl/CREDITS CREDITS.openssl
cp ext/spl/CREDITS CREDITS.spl
cp ext/libxml/CREDITS CREDITS.libxml
cp ext/zlib/CREDITS CREDITS.zlib

# cgi docs
cp sapi/cgi/CREDITS CREDITS.cgi

# cli docs
cp sapi/cli/CREDITS CREDITS.cli

# phar fixes
if [ -L %{buildroot}%{_bindir}/phar ]; then
    rm -f %{buildroot}%{_bindir}/phar
    mv %{buildroot}%{_bindir}/phar.phar %{buildroot}%{_bindir}/phar
fi

# house cleaning
rm -f %{buildroot}%{_bindir}/pear
rm -f %{buildroot}%{_libdir}/*.*a

# php-devel.i586: E: zero-length /usr/src/php-devel/extensions/pdo_firebird/EXPERIMENTAL
find %{buildroot}%{_usrsrc}/php-devel -type f -size 0 -exec rm -f {} \;

%multiarch_includes %{buildroot}%{_includedir}/php/main/build-defs.h

%multiarch_includes %{buildroot}%{_includedir}/php/main/php_config.h

%check
%if %{build_test}
# do a make test
export NO_INTERACTION=1
export PHPRC="."
export REPORT_EXIT_STATUS=2
export TEST_PHP_DETAILED=0
export TEST_PHP_ERROR_STYLE=EMACS
export TEST_PHP_LOG_FORMAT=LEODC
export PHP_INI_SCAN_DIR=/dev/null

# FAILING TESTS:
# unknown errors with ext/date/tests/oo_002.phpt probably because of php-5.2.5-systzdata.patch
# http://bugs.php.net/bug.php?id=22414 (claimed to be fixed in 2003, but seems not)
# unknown errors with ext/standard/tests/general_functions/phpinfo.phpt
# unknown errors with ext/standard/tests/strings/setlocale_*
disable_tests="ext/date/tests/oo_002.phpt \
ext/standard/tests/file/bug22414.phpt \
ext/standard/tests/general_functions/phpinfo.phpt \
ext/standard/tests/strings/setlocale_basic1.phpt \
ext/standard/tests/strings/setlocale_basic2.phpt \
ext/standard/tests/strings/setlocale_basic3.phpt \
ext/standard/tests/strings/setlocale_variation1.phpt \
ext/standard/tests/strings/setlocale_variation3.phpt \
ext/standard/tests/strings/setlocale_variation4.phpt \
ext/standard/tests/strings/setlocale_variation5.phpt"

[[ -n "$disable_tests" ]] && \
for f in $disable_tests; do
  [[ -f "$f" ]] && mv $f $f.disabled
done

TEST_PHP_EXECUTABLE=sapi/cli/php sapi/cli/php -c ./php-test.ini run-tests.php
%endif



%post fpm
#%_tmpfilescreate php-fpm
#%_post_service php-fpm

%preun fpm
#%_preun_service php-fpm

# rpm filetrigger to reload httpd when installing/removing php extensions
%transfiletriggerin --  %{_libdir}/php/extensions/
service httpd reload || :

%files doc
%doc LICENSE NEWS Zend/ZEND_LICENSE
%doc php.ini-production php.ini-development
%doc CREDITS.libxml CREDITS.zlib

%files ini
%{_docdir}/php
%config(noreplace) %{_sysconfdir}/php.ini
%config(noreplace) %{_sysconfdir}/php-cgi-fcgi.ini
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE102})
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE103})
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE104})
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE101})
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1066})
%dir %{_sysconfdir}/php.d
%dir %{_libdir}/php
%dir %{_datadir}/php
%dir %{_libdir}/php/extensions

%files -n apache-mod_php
%config(noreplace) %{_httpd_modconfdir}/*.conf
%{_httpd_moddir}/mod_php.so

%files -n %{libname}
%{_libdir}/libphp%{php_common_major}_common.so.%{php_common_major}*

%files cli
%doc CREDITS.cli
%{_bindir}/php
%{_mandir}/man1/php.1*

%files cgi
%doc CREDITS.cgi
%{_bindir}/php-cgi
%{_bindir}/php-fcgi
%{_mandir}/man1/php-cgi.1*

%files devel
%doc CODING_STANDARDS.md EXTENSIONS
%doc Zend/ZEND_*
%{_bindir}/php-config
%{_bindir}/phpize
%{_libdir}/libphp%{php_common_major}_common.so
%{_libdir}/php/build
%{_usrsrc}/php-devel
%{multiarch_includedir}/php/main/build-defs.h
%{multiarch_includedir}/php/main/php_config.h
%{_includedir}/php
%{_mandir}/man1/php-config.1*
%{_mandir}/man1/phpize.1*

%files openssl
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1012})
%{_libdir}/php/extensions/openssl.so

%files zlib
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1013})
%{_libdir}/php/extensions/zlib.so

%files bcmath
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1051})
%{_libdir}/php/extensions/bcmath.so

%files bz2
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE105})
%{_libdir}/php/extensions/bz2.so

%files calendar
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE106})
%{_libdir}/php/extensions/calendar.so

%files ctype
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE107})
%{_libdir}/php/extensions/ctype.so

%files curl
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE108})
%{_libdir}/php/extensions/curl.so

%files dba
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE109})
%{_libdir}/php/extensions/dba.so

%files dom
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1010})
%{_libdir}/php/extensions/dom.so

%files enchant
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1026})
%{_libdir}/php/extensions/enchant.so

%files exif
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1011})
%{_libdir}/php/extensions/exif.so

%files fileinfo
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1023})
%{_libdir}/php/extensions/fileinfo.so

%files filter
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1060})
%{_libdir}/php/extensions/filter.so

%files ftp
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1014})
%{_libdir}/php/extensions/ftp.so

%files gd
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1015})
%{_libdir}/php/extensions/gd.so

%files gettext
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1016})
%{_libdir}/php/extensions/gettext.so

%files gmp
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1017})
%{_libdir}/php/extensions/gmp.so

%files iconv
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1018})
%{_libdir}/php/extensions/iconv.so

%files imap
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1019})
%{_libdir}/php/extensions/imap.so

%files intl
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1020})
%{_libdir}/php/extensions/intl.so

%files json
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1061})
%{_libdir}/php/extensions/json.so

%files ldap
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1021})
%{_libdir}/php/extensions/ldap.so

%files mbstring
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1022})
%{_libdir}/php/extensions/mbstring.so

%files mysqli
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1025})
%{_libdir}/php/extensions/mysqli.so

%files mysqlnd
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1024})
%{_libdir}/php/extensions/mysqlnd.so

%files odbc
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1027})
%{_libdir}/php/extensions/odbc.so

%files opcache
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1064})
%{_libdir}/php/extensions/opcache.so

%files pcntl
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1028})
%{_libdir}/php/extensions/pcntl.so

%files pdo
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1052})
%{_libdir}/php/extensions/pdo.so

%files pdo_dblib
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1053})
%{_libdir}/php/extensions/pdo_dblib.so

%files pdo_firebird
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1058})
%{_libdir}/php/extensions/pdo_firebird.so

%files pdo_mysql
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1054})
%{_libdir}/php/extensions/pdo_mysql.so

%files pdo_odbc
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1055})
%{_libdir}/php/extensions/pdo_odbc.so

%files pdo_pgsql
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1056})
%{_libdir}/php/extensions/pdo_pgsql.so

%files pdo_sqlite
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1057})
%{_libdir}/php/extensions/pdo_sqlite.so

%files pgsql
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1030})
%{_libdir}/php/extensions/pgsql.so

%files phar
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1063})
%{_libdir}/php/extensions/phar.so
%{_bindir}/phar
%{_mandir}/man1/phar.1*
%{_mandir}/man1/phar.phar.1*

%files posix
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1031})
%{_libdir}/php/extensions/posix.so

%files readline
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1032})
%{_libdir}/php/extensions/readline.so

%files session
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1034})
%config(noreplace) %{_sysconfdir}/cron.d/php
%{_libdir}/php/extensions/session.so
%{_libdir}/php/maxlifetime
%attr(01733,apache,apache) %dir /var/lib/php

%files shmop
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1035})
%{_libdir}/php/extensions/shmop.so

%files snmp
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1036})
%{_libdir}/php/extensions/snmp.so

%files soap
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1037})
%{_libdir}/php/extensions/soap.so

%files sockets
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1038})
%{_libdir}/php/extensions/sockets.so

%files sodium
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1065})
%{_libdir}/php/extensions/sodium.so

%files sqlite3
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1059})
%{_libdir}/php/extensions/sqlite3.so

%files sysvmsg
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1040})
%{_libdir}/php/extensions/sysvmsg.so

%files sysvsem
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1041})
%{_libdir}/php/extensions/sysvsem.so

%files sysvshm
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1042})
%{_libdir}/php/extensions/sysvshm.so

%files tidy
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1043})
%{_libdir}/php/extensions/tidy.so

%files tokenizer
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1044})
%{_libdir}/php/extensions/tokenizer.so

%files xmlreader
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1048})
%{_libdir}/php/extensions/xmlreader.so

%files xmlrpc
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1046})
%{_libdir}/php/extensions/xmlrpc.so

%files xmlwriter
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1050})
%{_libdir}/php/extensions/xmlwriter.so

%files xsl
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1049})
%{_libdir}/php/extensions/xsl.so

%files zip
%config(noreplace) %{_sysconfdir}/php.d/%(basename %{SOURCE1062})
%{_libdir}/php/extensions/zip.so

%files fpm
%doc sapi/fpm/CREDITS sapi/fpm/LICENSE sapi/fpm/status.html
#%{_unitdir}/php-fpm.service
%config(noreplace) %{_httpd_modconfdir}/00-php-fpm.conf
%config(noreplace) %{_sysconfdir}/php-fpm.conf
%config(noreplace) %{_sysconfdir}/sysconfig/php-fpm
%{_sysconfdir}/logrotate.d/php-fpm
%dir %{_sysconfdir}/php-fpm.d
%config(noreplace) %{_sysconfdir}/php-fpm.d/default.conf
%config(noreplace) %{_sysconfdir}/php-fpm.d/www.conf
%{_sbindir}/php-fpm
%{_mandir}/man8/php-fpm.8*
%attr(0711,apache,apache) %dir /var/lib/php-fpm
%attr(0711,apache,apache) %dir /var/log/php-fpm
#%{_tmpfilesdir}/php-fpm.conf

%files -n phpdbg
%doc sapi/phpdbg/CREDITS sapi/phpdbg/README.md
%doc sapi/phpdbg/*.php
%{_bindir}/phpdbg
%{_mandir}/man1/phpdbg.1*


%changelog
* Tue Jan 21 2020 tex - 7.4.2-1pclos2020
- new version

* Thu Dec 19 2019 tex - 7.4.1-1pclos2020
- new version

* Mon Dec 02 2019 tex - 7.4.0-3pclos2019
- rebuild against updates

* Fri Nov 29 2019 tex - 7.4.0-2pclos2019
- fix php.ini
